;**********************************************************************;
;*                 A T O M I C   D E B U G G E R                      *;
;*--------------------------------------------------------------------*;
;*    doel           : machinetaal debugger voor Atom-in-PC met       *;
;*                     ondersteuning van 6502, 65C02 en 65802         *;
;*--------------------------------------------------------------------*;
;*    filenaam       : bbc.inc                                        *;
;*    auteur         : Roland Leurs                                   *;
;*                     The Atomic Development Studio                  *;
;*    ontwikkeld     : maart 1998                                     *;
;*    laatste update :                                                *;
;*--------------------------------------------------------------------*;
;*    assembleren    : als include file opnemen in debug.asm          *;
;**********************************************************************;

count           equ     $1E
zp              equ     $80
work            equ     $800            ;werkruimte
semafoor        equ     $FA             ;semafoor voor pc communicatie
VIA             equ     $B810           ;via voor timer interrupts
runscrn         equ     1               ;trace output scherm
semset          equ     $1B
semclr          equ     $1A
hexteken        equ     '&'             ;teken voor hexadecimaal aanduiding
immteken        equ     '#'             ;teken voor immediate adressering

wrch            equ     $1FEE
rdch            equ     $1FE0
osbyte          equ     $1FF4
leesbyte        equ     $1FC8
zendbyte        equ     $1FC5
crlf            equ     $1FE7

PRCHAR_NL       EQU     $1FE3

PRSPACES        jmp     PRSPACE
brkhandler      equ     $F402
