#include <stdio.h>
#include "sprites.h"
#include "mousecur.h"
#include "memoryen.h"		/* <--- select your language module here */
 
#define FONTFILE	"memory.fnt"
#define MEMSPRITES	"memsprites"

/* Globale variabelen */
int I, K, H, V;
int AA[25], KK[48], CC[48];
int spelers, kaarten;

void backside(int x, int y, int c)
	{
	vga_setcolor(c);
	block(FILL,x*33+55,y*33+32,x*33+86,y*33+1);
	}

void frontside(int x, int y, int i)
	{
	sprite_set(i, x*33+55, y*33+1);
	}

void verdeel(int p)
	{
	int i,k;
	for(i=1; i<=kaarten; i++)
		{
		k=abs(time(NULL)+random())%48;
		while (KK[k]>-1)
			k=abs(time(NULL)*random())%48;
		KK[k]=p;
		}
	}

void schud(void)
	{
	int i;
	for (i=1; i<=48/kaarten; i++)
		verdeel(i);
	}

void raap_kaart(void)
	{
	int x,y,b=0;
	H=8;
	V=6;
	vga_setcolor(8);
	block(FILL,0,8,8,0);
	vga_setcolor(0);
	drawline(1,1,8,8);
	drawline(7,1,0,8);
	mouse_on();
	while ((H<0 || H>7) || (V<0 || V>5) || CC[V*8+H]==0)
		{
		usleep(100000);
		mouse_move();
		while (!mouse_getbutton()&7)
			mouse_move();
		x=mouse_getx();
		y=mouse_gety();
		if (x<8 && y<8)
			{
			txmod();
			system("clear");
			exit(1);
			}
		for(b=0; b<=7; b++)
			if ((x>b*33+55) && (x<b*33+86)) H=b;
		for(b=0; b<=5; b++)
			if ((y>b*33+1) && (y<b*33+55)) V=b;
		}
	mouse_off();
	I=V*8+H;
	CC[I]=0;
	}

int main(void)
	{
	int i,s,x,y, aandebeurt;
	int score[3];
	char sprdata[1024];
	char *naam[3], letter[]="*";
	FILE *fp;

	if (loadfont(FONTFILE))
		{
		printf("%s: %s\n", FONTFILE, ERR1);
		exit(2);
		}
	sprite_init(25);
	fp=fopen(MEMSPRITES, "r");
	if (!fp)
		{
		printf("%s: %s\n", MEMSPRITES, ERR2);
		exit(3);
		}
	for(s=1; s<25; s++)
		{
		for(i=0; i<1024; i++)
			sprdata[i]=fgetc(fp);
		sprite_def(s, sprdata);
		}
	fclose(fp);
	define_mouse_cursor();
	grmod(MOUSE);
	vga_setmode(5);
	X__max=319;
	Y__max=199;
	vga_setcolor(1);
	block(FILL,0,199,319,0);

	/* teken beginscherm en vraag naar aantal spelers */
	for(x=0; x<6; x++)
		{
		for (y=0; y<3; y++)
			{
			y==1 ? backside(x,y,11) : frontside(x,y,random()%24);
			}
		}
	vga_setcolor(0);
	gwrite("M", 65, 38, 2, 2);
	gwrite("E", 97, 38, 2, 2);
	gwrite("M", 129, 38, 2, 2);
	gwrite("O", 161, 38, 2, 2);
	gwrite("R", 193, 38, 2, 2);
	gwrite("Y", 225, 38, 2, 2);
	vga_setcolor(11);
	gwrite(STR1, 30, 99, 1, 1);
	vga_setcolor(2);
	gwrite(STR2, 30, 120, 1, 1);
	for (x=0; x<320; x+=80)
		{
		printdec((x/80+1), 1, x+32, 184, 2, 1);
		block(0, x, 199, x+79, 180);
		}
	mouse_on();
	while(!(mouse_getbutton()&MOUSE_LEFTBUTTON) || (mouse_gety() < 180))
		mouse_move();
	mouse_off();
	spelers=1+mouse_getx()/80;

	/* Reserveer geheugen voor de spelernamen en vraag deze, reset score */
	vga_setcolor(1);
	block(FILL,0,199,319,120);
	for(i=0; i<spelers; i++)
		{
		naam[i]=malloc(16);
		score[i]=0;
		}
	vga_setcolor(14);
	if (spelers>=1)
		{
		gwrite(STR3, 10, 120, 1, 1);
		gread(naam[0], 160, 120, 1, 1, 8, 14, 1);
		}
	if (spelers>=2)
		{
		gwrite(STR4, 10, 140, 1, 1);
		gread(naam[1], 160, 140, 1, 1, 8, 14, 1);
		}
	if (spelers>=3)
		{
		gwrite(STR5, 10, 160, 1, 1);
		gread(naam[2], 160, 160, 1, 1, 8, 14, 1);
		}
	if (spelers==4)
		{
		gwrite(STR6, 10, 180, 1, 1);
		gread(naam[3], 160, 180, 1, 1, 8, 14, 1);
		}

	/* Vraag naar het aantal gelijke kaarten */
	vga_setcolor(1);
	block(FILL,0,199,319,120);
	vga_setcolor(2);
	gwrite(STR7, 30, 120, 1, 1);
	gwrite("2  3   4  6  12 24", 16, 184, 2, 1);
	for (x=0; x<320; x+=53)
		block(OPEN, x, 199, x+52, 180);
	mouse_on();
	while(!(mouse_getbutton()&MOUSE_LEFTBUTTON) || (mouse_gety() < 180))
		mouse_move();
	mouse_off();
	x=mouse_getx();
	if (x>2   && x<50 ) kaarten=2;
	if (x>54  && x<103) kaarten=3;
	if (x>107 && x<157) kaarten=4;
	if (x>160 && x<209) kaarten=6;
	if (x>213 && x<263) kaarten=12;
	if (x>266 && x<315) kaarten=24;

	/* Initialisatie van het spel */
	for(i=0; i<48; i++)
		{
		KK[i]=-1;
		CC[i]=1;
		}
	schud();
	K=48;
	aandebeurt=0;

	/* Teken het spelscherm */
        vga_setcolor(1);
        block(FILL,0,199,319,0);
	for(y=0; y<6; y++)
		for(x=0; x<8; x++)
			{
			backside(x,y,14);
			}
	
	/* Spelen maar */
	while(K)
		{
		vga_setcolor(1);
		block(FILL, 0, 199, 54, 0);
		vga_setcolor(15);
		for(i=0; i<strlen(naam[aandebeurt]); i++)
			{
			letter[0]=naam[aandebeurt][i];
			gwrite(letter, 24, i*16+32, 1, 1);
			}
		for(i=1; i<=kaarten; i++)
			{
			vga_setcolor(1);
			block(1, 0, 199, 54, 160);
			vga_setcolor(14);
			gwrite(STR8, 5, 160, 1, 1);
			printdec(i, 2, 5, 170, 1, 1);
			gwrite(STR9, 36, 170, 1, 1);
			gwrite(STR10, 5, 180, 1, 1);
			raap_kaart();
			AA[i]=I;
			frontside(H, V, KK[I]);
			}
		s=1;
		for(i=2; i<=kaarten; i++)
			if(KK[AA[i]] != KK[AA[1]])
				s=0;
		score[aandebeurt]+=s;
		sleep(kaarten);
		for(i=1; i<=kaarten; i++)
			{
			if(!s) CC[AA[i]]=1;
			backside(AA[i]-8*(AA[i]/8), AA[i]/8, 14-13*s);
			}
		if(s==1)
			{
			K-=kaarten;
			}
		else
			{
			aandebeurt++;
			if(aandebeurt==spelers) aandebeurt=0;
			}
		}
        vga_setcolor(1);
        block(FILL,0,199,319,0);
	vga_setcolor(10);
	gwrite(STR11, 0, 0, 2, 2);
	for(i=0; i<spelers; i++)
		{
		vga_setcolor(4);
		gwrite(naam[i], 10, 40+i*40, 2, 2);
		vga_setcolor(14);
		printdec(score[i], 2, 200, 40+i*40, 2, 2);
		}

	while(!vga_getkey()) ;
	txmod();
	system("clear");
	return(0);
	}

	
