;**********************************************************************;
;*                 A T O M I C   D E B U G G E R                      *;
;*--------------------------------------------------------------------*;
;*    doel           : machinetaal debugger voor Atom-in-PC met       *;
;*                     ondersteuning van 6502, 65C02 en 65802         *;
;*--------------------------------------------------------------------*;
;*    filenaam       : atom.inc                                       *;
;*    auteur         : Roland Leurs                                   *;
;*                     The Atomic Development Studio                  *;
;*    ontwikkeld     : maart 1998                                     *;
;*    laatste update : augustus 1998                                  *;
;*--------------------------------------------------------------------*;
;*    assembleren    : als include file opnemen in debug.asm          *;
;**********************************************************************;

count           equ     $07             ;count variabele
zp              equ     $70
work            equ     $9E80           ;werkruimte
semafoor        equ     $CF             ;semafoor voor pc communicatie
VIA             equ     $B810           ;via voor timer interrupts
runscrn         equ     1               ;trace output scherm
semset          equ     $0B
semclr          equ     $0A
hexteken        equ     '#'             ;teken voor hexadecimaal aanduiding
immteken        equ     '@'             ;teken voor immediate adressering

swrch           equ     $0208
rdch            equ     $FFE3
osbyte          equ     $FFC2
leesbyte        equ     $FFC5
zendbyte        equ     $FFC8
brkhandler      equ     $C9B2
resextv         equ     $04F7           ;user reset extension vector
