/* Console.h bevat enkele functies die de opmaak van programma's
   op de console wat kan verfraaien. Deze functies maken gebruik 
   van Ansi Escape Sequences */

#include <string.h>

#define 	BOLD	1
#define		BLINK	5
#define		REVERSE	7
#define		NORMAL	0
 
#define	cprintf	printf

enum fgcolor	{BLACK=30, RED, GREEN, BROWN, BLUE, MAGENTA, CYAN, WHITE, YELLOW};
enum bgcolor	{BG_BLACK=40, BG_RED, BG_GREEN, BG_BROWN, BG_BLUE, BG_MAGENTA, BG_CYAN, BG_WHITE};

void gotoxy(int x, int y)
   {
   	char es[50];			/* string voor escape sequence */
   	char posx[25];			/* string voor x positie */
   	char posy[25];			/* string voor y positie */
   	sprintf(posx, "%d", x);		/* zet x van int naar string om */
   	sprintf(posy, "%d", y);		/* zet y van int naar string om */
   	es[0]='\0';			/* maak string leeg */
   	strcat(es,"\x1B[");		/* maak vertikale substring */
   	strcat(es,posy);
   	strcat(es,"d");
   	strcat(es,"\x1B[");		/* voeg hor. substring toe */
   	strcat(es,posx);
   	strcat(es,"G");
   	printf("%s", es);		/* Plaats de cursor naar x,y */
   	}

void clrscr(void)
	{
	printf("\x1B[2J"
	        "\x1B[0d"
		"\x1B[0G");
	}

void _textattr(int attrib)
	{
	if (attrib==YELLOW)
		{
		_textattr(BROWN);
		_textattr(BOLD);
		}
	else
		{
		char es[50];
        	char attr[25];
        	sprintf(attr, "%d", attrib);
        	es[0]='\0';
        	strcat(es,"\x1B[");
        	strcat(es,attr);
        	strcat(es,"m");
		printf("%s", es);
		}
	}
