/* OS dependant routines and values */

char platform[]="Linux";

#include <sys/time.h>
#include <asm/io.h>
#include <sys/io.h>
#include "conio.h"

#define key_pgup	'5'
#define key_pgdn	'6'
#define key_curup	'A'
#define key_curdn	'B'
#define key_f1		'P'
#define key_f2		'Q'
#define key_f3		'R'
#define key_f4		'S'
#define key_1		'1'
#define key_2		'2'
#define key_3		'3'
#define key_4		'4'
#define key_9		'9'
#define key_0		'0'
#define space		' '
#define enter		0x0A
#define key_r		'R'
#define key_s		'S'
#define key_h		'H'
#define key_m		'M'
#define key_q		'Q'
#define key_a		'A'
#define key_c		'C'
#define key_g		'G'
#define key_bs		0x08
#define key_delete	0x7F

#define BASEPORT 0x378

fd_set rfds;
struct timeval tv;

void progstart(void)
	{
        if (ioperm(BASEPORT,4,1))
                {
                perror("ioperm: ");
                exit(4);
                }
/*	system("consolechars -d"); */
	system("stty cbreak");
	system("stty -echo");
	}

void progend(void)
	{
	system("stty -cbreak");
	system("stty echo");
        if (ioperm(BASEPORT,4,0))
                {
                perror("ioperm: ");
                exit(4);
                }
	}

char readkey(void)
	{
	return getchar();
	}

int kbhit(void)
        {
        /* Watch stdin (fd 0) to see when it has input. */
        FD_ZERO(&rfds);
        FD_SET(0, &rfds);
        tv.tv_sec = 0;
        tv.tv_usec = 1;
        return select(1, &rfds, NULL, NULL, &tv);
        }
