
	org	0x00
	goto	init

	org	0x04
	goto	isr

	org	0x20
init:	movlw	0xEF		; preset timer
	movwf	RTCC		
	bsf	STATUS,5	; select bank 1
	bcf	OPTION,5	; kies voor timer mode
	bcf	STATUS,5	; terug naar bank 0
	bsf	INTCON,5	; enable timer interrupts
	bsf	INTCON,7	; enable interrupt
loop:	movf	PORT_A,W	; lees status van A poort
	andlw	0x1F		; wis hoogste drie bits
	addwf	0x10,W		; tel de "timer bits" erbij
	movwf	PORT_B
	goto	loop		; eindeloze lus

isr:	bcf	INTCON,2	; wis interrupt vlag
	movwf	0x11		; bewaar W register
	movlw	0xEF		; preset timer
	movwf	RTCC
	movf	0x10,W		; verhoog teller in interrupt routine
	addlw	0x20
	movwf	0x10	
	movf	0x11,W		; herstel W register
	retfie			; einde interrupt routine

	FUSE 	0x3FF9

